Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 502)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 503)
@@ -18,204 +18,157 @@
  */
 #include <pjsua-lib/pjsua.h>
-#include <pj/log.h>
-#include "pjsua_imp.h"
-
-/*
- * pjsua_call.c
- *
- * Call (INVITE) related stuffs.
- */
-
-#define THIS_FILE   "pjsua_call.c"
-
-
-#define REFRESH_CALL_TIMER	0x63
-#define HANGUP_CALL_TIMER	0x64
-
-/* Proto */
-static void schedule_call_timer( pjsua_call *call, pj_timer_entry *e,
-				 int timer_type, int duration );
-
-/*
- * Timer callback when UAS needs to send re-INVITE to see if remote
- * is still there.
- */
-static void call_on_timer(pj_timer_heap_t *ht, pj_timer_entry *e)
-{
-    pjsua_call *call = e->user_data;
-
-    PJ_UNUSED_ARG(ht);
-
-    if (e->id == REFRESH_CALL_TIMER) {
-
-	/* If call is still not connected, hangup. */
-	if (call->inv->state != PJSIP_INV_STATE_CONFIRMED) {
-	    PJ_LOG(3,(THIS_FILE, "Refresh call timer is called when "
-		      "invite is still not confirmed. Call %d will "
-		      "disconnect.", call->index));
-	    pjsua_call_hangup(call->index);
-	} else {
-	    PJ_LOG(3,(THIS_FILE, "Refreshing call %d", call->index));
-	    schedule_call_timer(call,e,REFRESH_CALL_TIMER,
-				pjsua.config.uas_refresh);
-	    pjsua_call_reinvite(call->index);
-	}
-
-    } else if (e->id == HANGUP_CALL_TIMER) {
-	PJ_LOG(3,(THIS_FILE, "Call %d duration exceeded, disconnecting call",
-			     call->index));
-	pjsua_call_hangup(call->index);
-
-    }
-}
-
-/*
- * Schedule call timer.
- */
-static void schedule_call_timer( pjsua_call *call, pj_timer_entry *e,
-				 int timer_type, int duration )
-{
-    pj_time_val timeout;
-
-    if (duration == 0) {
-	/* Cancel timer. */
-	if (e->id != 0) {
-	    pjsip_endpt_cancel_timer(pjsua.endpt, e);
-	    e->id = 0;
-	}
-
-    } else {
-	/* Schedule timer. */
-	timeout.sec = duration;
-	timeout.msec = 0;
-
-	e->cb = &call_on_timer;
-	e->id = timer_type;
-	e->user_data = call;
-
-	pjsip_endpt_schedule_timer( pjsua.endpt, e, &timeout);
-    }
-}
-
-
-/*
- * Destroy the call's media
- */
-static pj_status_t call_destroy_media(int call_index)
-{
-    pjsua_call *call = &pjsua.calls[call_index];
-
-    if (call->conf_slot > 0) {
-	pjmedia_conf_remove_port(pjsua.mconf, call->conf_slot);
-	call->conf_slot = 0;
-    }
-
-    if (call->session) {
-	/* Destroy session (this will also close RTP/RTCP sockets). */
-	pjmedia_session_destroy(call->session);
-	call->session = NULL;
-
-	PJ_LOG(3,(THIS_FILE, "Media session for call %d is destroyed", 
-			     call_index));
-
-    }
-
+#include <pjsua-lib/pjsua_internal.h>
+
+
+#define THIS_FILE		"pjsua_call.c"
+
+
+/* This callback receives notification from invite session when the
+ * session state has changed.
+ */
+static void pjsua_call_on_state_changed(pjsip_inv_session *inv, 
+					pjsip_event *e);
+
+/* This callback is called by invite session framework when UAC session
+ * has forked.
+ */
+static void pjsua_call_on_forked( pjsip_inv_session *inv, 
+				  pjsip_event *e);
+
+/*
+ * Callback to be called when SDP offer/answer negotiation has just completed
+ * in the session. This function will start/update media if negotiation
+ * has succeeded.
+ */
+static void pjsua_call_on_media_update(pjsip_inv_session *inv,
+				       pj_status_t status);
+
+/*
+ * Called when session received new offer.
+ */
+static void pjsua_call_on_rx_offer(pjsip_inv_session *inv,
+				   const pjmedia_sdp_session *offer);
+
+/*
+ * This callback is called when transaction state has changed in INVITE
+ * session. We use this to trap:
+ *  - incoming REFER request.
+ *  - incoming MESSAGE request.
+ */
+static void pjsua_call_on_tsx_state_changed(pjsip_inv_session *inv,
+					    pjsip_transaction *tsx,
+					    pjsip_event *e);
+
+
+/* Destroy the call's media */
+static pj_status_t call_destroy_media(int call_id);
+
+/* Create inactive SDP for call hold. */
+static pj_status_t create_inactive_sdp(pjsua_call *call,
+				       pjmedia_sdp_session **p_answer);
+
+
+/*
+ * Reset call descriptor.
+ */
+static void reset_call(pjsua_call_id id)
+{
+    pjsua_call *call = &pjsua_var.calls[id];
+
+    call->index = id;
+    call->inv = NULL;
+    call->user_data = NULL;
+    call->session = NULL;
+    call->xfer_sub = NULL;
+    call->last_code = 0;
+    call->conf_slot = PJSUA_INVALID_ID;
+    call->last_text.ptr = call->last_text_buf_;
+    call->last_text.slen = 0;
+}
+
+
+/*
+ * Init call subsystem.
+ */
+pj_status_t pjsua_call_subsys_init(const pjsua_config *cfg)
+{
+    pjsip_inv_callback inv_cb;
+    unsigned i;
+    pj_status_t status;
+
+    /* Init calls array. */
+    for (i=0; i<PJ_ARRAY_SIZE(pjsua_var.calls); ++i)
+	reset_call(i);
+
+    /* Copy config */
+    pjsua_config_dup(pjsua_var.pool, &pjsua_var.ua_cfg, cfg);
+
+    /* Initialize invite session callback. */
+    pj_memset(&inv_cb, 0, sizeof(inv_cb));
+    inv_cb.on_state_changed = &pjsua_call_on_state_changed;
+    inv_cb.on_new_session = &pjsua_call_on_forked;
+    inv_cb.on_media_update = &pjsua_call_on_media_update;
+    inv_cb.on_rx_offer = &pjsua_call_on_rx_offer;
+    inv_cb.on_tsx_state_changed = &pjsua_call_on_tsx_state_changed;
+
+
+    /* Initialize invite session module: */
+    status = pjsip_inv_usage_init(pjsua_var.endpt, &inv_cb);
+    PJ_ASSERT_RETURN(status == PJ_SUCCESS, status);
+
+    return status;
+}
+
+
+/*
+ * Start call subsystem.
+ */
+pj_status_t pjsua_call_subsys_start(void)
+{
+    /* Nothing to do */
     return PJ_SUCCESS;
 }
 
 
-/**
+/*
  * Get maximum number of calls configured in pjsua.
  */
 PJ_DEF(unsigned) pjsua_call_get_max_count(void)
 {
-    return pjsua.config.max_calls;
-}
-
-
-/**
- * Get current number of active calls.
+    return pjsua_var.ua_cfg.max_calls;
+}
+
+
+/*
+ * Get number of currently active calls.
  */
 PJ_DEF(unsigned) pjsua_call_get_count(void)
 {
-    return pjsua.call_cnt;
-}
-
-
-/**
- * Check if the specified call is active.
- */
-PJ_DEF(pj_bool_t) pjsua_call_is_active(unsigned call_index)
-{
-    PJ_ASSERT_RETURN(call_index < pjsua.config.max_calls,
-		     PJ_EINVAL);
-    return pjsua.calls[call_index].inv != NULL &&
-	   pjsua.calls[call_index].inv->state != PJSIP_INV_STATE_DISCONNECTED;
-}
-
-/**
- * Check if call has a media session.
- */
-PJ_DEF(pj_bool_t) pjsua_call_has_media(unsigned call_index)
-{
-    PJ_ASSERT_RETURN(call_index < pjsua.config.max_calls, PJ_EINVAL);
-    return pjsua.calls[call_index].session != NULL;
-}
-
-
-/**
- * Get call info.
- */
-PJ_DEF(pj_status_t) pjsua_call_get_info( unsigned call_index,
-					 pjsua_call_info *info)
-{
-    pjsua_call *call;
-
-    PJ_ASSERT_RETURN(call_index < pjsua.config.max_calls,
-		     PJ_EINVAL);
-
-    pj_memset(info, 0, sizeof(pjsua_call_info));
-
-    call = &pjsua.calls[call_index];
-    info->active = pjsua_call_is_active(call_index);
-
-    if (call->inv == NULL)
-	return PJ_SUCCESS;
-
-    info->index = call_index;
-    info->role = call->inv->role;
-    info->local_info = call->inv->dlg->local.info_str;
-    info->remote_info = call->inv->dlg->remote.info_str;
-    info->state = call->inv->state;
-    info->state_text = pj_str((char*)pjsip_inv_state_name(info->state));
-    
-    if (info->state >= PJSIP_INV_STATE_DISCONNECTED) {
-
-	info->total_duration = call->dis_time;
-	PJ_TIME_VAL_SUB(info->total_duration, call->start_time);
-
-	if (call->conn_time.sec) {
-	    info->connect_duration = call->dis_time;
-	    PJ_TIME_VAL_SUB(info->total_duration, call->conn_time);
-	}
-
-    } else if (info->state == PJSIP_INV_STATE_CONFIRMED) {
-
-	pj_gettimeofday(&info->total_duration);
-	PJ_TIME_VAL_SUB(info->total_duration, call->start_time);
-
-	pj_gettimeofday(&info->connect_duration);
-	PJ_TIME_VAL_SUB(info->connect_duration, call->conn_time);
-
-    } else {
-	pj_gettimeofday(&info->total_duration);
-	PJ_TIME_VAL_SUB(info->total_duration, call->start_time);
-    }
-
-    info->last_status = call->last_code;
-    info->last_status_text = *pjsip_get_status_text(info->last_status);
-
-    info->has_media = (call->session != NULL);
-    info->conf_slot = call->conf_slot;
+    return pjsua_var.call_cnt;
+}
+
+
+/*
+ * Enum calls.
+ */
+PJ_DEF(pj_status_t) pjsua_enum_calls( pjsua_call_id ids[],
+				      unsigned *count)
+{
+    unsigned i, c;
+
+    PJ_ASSERT_RETURN(ids && *count, PJ_EINVAL);
+
+    PJSUA_LOCK();
+
+    for (i=0, c=0; c<*count && i<pjsua_var.ua_cfg.max_calls; ++i) {
+	if (!pjsua_var.calls[i].inv)
+	    continue;
+	ids[c] = i;
+	++c;
+    }
+
+    *count = c;
+
+    PJSUA_UNLOCK();
 
     return PJ_SUCCESS;
@@ -223,68 +176,68 @@
 
 
-/**
- * Duplicate call info.
- */
-PJ_DEF(void) pjsua_call_info_dup( pj_pool_t *pool,
-				  pjsua_call_info *dst_info,
-				  const pjsua_call_info *src_info)
-{
-    PJ_ASSERT_ON_FAIL(pool && dst_info && src_info, return);
-
-    pj_memcpy(dst_info, src_info, sizeof(pjsua_call_info));
-
-    pj_strdup(pool, &dst_info->local_info, &src_info->local_info);
-    pj_strdup(pool, &dst_info->remote_info, &src_info->remote_info);
-    
-    /* state_text and cause_text belong to pjsip, so don't need to be
-     * duplicated because they'll always be available.
-     */
-}
-
-
-/**
- * Make outgoing call.
- */
-PJ_DEF(pj_status_t) pjsua_call_make_call(unsigned acc_index,
-					 const pj_str_t *dest_uri,
-					 int *p_call_index)
+/*
+ * Make outgoing call to the specified URI using the specified account.
+ */
+PJ_DEF(pj_status_t) pjsua_call_make_call( pjsua_acc_id acc_id,
+					  const pj_str_t *dest_uri,
+					  unsigned options,
+					  void *user_data,
+					  const pjsua_msg_data *msg_data,
+					  pjsua_call_id *p_call_id)
 {
     pjsip_dialog *dlg = NULL;
     pjmedia_sdp_session *offer;
     pjsip_inv_session *inv = NULL;
-    unsigned call_index;
+    pjsua_acc *acc;
+    pjsua_call *call;
+    unsigned call_id;
     pjsip_tx_data *tdata;
     pj_status_t status;
 
 
-    PJ_ASSERT_RETURN(acc_index==0 || acc_index < pjsua.config.acc_cnt, 
+    /* Check that account is valid */
+    PJ_ASSERT_RETURN(acc_id>=0 || acc_id<PJ_ARRAY_SIZE(pjsua_var.acc), 
 		     PJ_EINVAL);
 
+    /* Options must be zero for now */
+    PJ_ASSERT_RETURN(options == 0, PJ_EINVAL);
+
+    PJSUA_LOCK();
+
+    acc = &pjsua_var.acc[acc_id];
+    if (!acc->valid) {
+	pjsua_perror(THIS_FILE, "Unable to make call because account "
+		     "is not valid", PJ_EINVALIDOP);
+	PJSUA_UNLOCK();
+	return PJ_EINVALIDOP;
+    }
 
     /* Find free call slot. */
-    for (call_index=0; call_index<pjsua.config.max_calls; ++call_index) {
-	if (pjsua.calls[call_index].inv == NULL)
+    for (call_id=0; call_id<pjsua_var.ua_cfg.max_calls; ++call_id) {
+	if (pjsua_var.calls[call_id].inv == NULL)
 	    break;
     }
 
-    if (call_index == pjsua.config.max_calls) {
-	PJ_LOG(3,(THIS_FILE, "Error: too many calls!"));
+    if (call_id == pjsua_var.ua_cfg.max_calls) {
+	pjsua_perror(THIS_FILE, "Error making file", PJ_ETOOMANY);
+	PJSUA_UNLOCK();
 	return PJ_ETOOMANY;
     }
 
+    call = &pjsua_var.calls[call_id];
+
     /* Mark call start time. */
-    pj_gettimeofday(&pjsua.calls[call_index].start_time);
+    pj_gettimeofday(&call->start_time);
 
     /* Reset first response time */
-    pjsua.calls[call_index].res_time.sec = 0;
+    call->res_time.sec = 0;
 
     /* Create outgoing dialog: */
     status = pjsip_dlg_create_uac( pjsip_ua_instance(), 
-				   &pjsua.config.acc_config[acc_index].id,
-				   &pjsua.config.acc_config[acc_index].contact,
-				   dest_uri, dest_uri,
-				   &dlg);
+				   &acc->cfg.id, &acc->cfg.contact,
+				   dest_uri, dest_uri, &dlg);
     if (status != PJ_SUCCESS) {
 	pjsua_perror(THIS_FILE, "Dialog creation failed", status);
+	PJSUA_UNLOCK();
 	return status;
     }
@@ -292,7 +245,6 @@
     /* Get media capability from media endpoint: */
 
-    status = pjmedia_endpt_create_sdp( pjsua.med_endpt, dlg->pool, 1, 
-				       &pjsua.calls[call_index].skinfo, 
-				       &offer);
+    status = pjmedia_endpt_create_sdp( pjsua_var.med_endpt, dlg->pool, 1, 
+				       &call->skinfo, &offer);
     if (status != PJ_SUCCESS) {
 	pjsua_perror(THIS_FILE, "pjmedia unable to create SDP", status);
@@ -311,22 +263,21 @@
     /* Create and associate our data in the session. */
 
-    pjsua.calls[call_index].inv = inv;
-
-    dlg->mod_data[pjsua.mod.id] = &pjsua.calls[call_index];
-    inv->mod_data[pjsua.mod.id] = &pjsua.calls[call_index];
-
+    call->inv = inv;
+
+    dlg->mod_data[pjsua_var.mod.id] = call;
+    inv->mod_data[pjsua_var.mod.id] = call;
+
+    /* Attach user data */
+    call->user_data = user_data;
 
     /* Set dialog Route-Set: */
-
-    if (!pj_list_empty(&pjsua.acc[acc_index].route_set))
-	pjsip_dlg_set_route_set(dlg, &pjsua.acc[acc_index].route_set);
+    if (!pj_list_empty(&acc->route_set))
+	pjsip_dlg_set_route_set(dlg, &acc->route_set);
 
 
     /* Set credentials: */
-    if (pjsua.config.acc_config[acc_index].cred_count) {
-	pjsua_acc_config *acc_cfg = &pjsua.config.acc_config[acc_index];
+    if (acc->cred_cnt) {
 	pjsip_auth_clt_set_credentials( &dlg->auth_sess, 
-					acc_cfg->cred_count,
-					acc_cfg->cred_info);
+					acc->cred_cnt, acc->cred);
     }
 
@@ -341,4 +292,8 @@
     }
 
+
+    /* Add additional headers etc */
+
+    pjsua_process_msg_data( tdata, msg_data);
 
     /* Send initial INVITE: */
@@ -357,11 +312,12 @@
     }
 
-
     /* Done. */
 
-    ++pjsua.call_cnt;
-
-    if (p_call_index)
-	*p_call_index = call_index;
+    ++pjsua_var.call_cnt;
+
+    if (p_call_id)
+	*p_call_id = call_id;
+
+    PJSUA_UNLOCK();
 
     return PJ_SUCCESS;
@@ -375,38 +331,9 @@
     }
 
-    if (call_index != -1) {
-	pjsua.calls[call_index].inv = NULL;
-    }
-    return status;
-}
-
-
-/**
- * Answer call.
- */
-PJ_DEF(pj_status_t) pjsua_call_answer(int call_index, int code)
-{
-    pjsip_tx_data *tdata;
-    pj_status_t status;
-
-    PJ_ASSERT_RETURN( call_index >= 0 && 
-		      call_index < (int)pjsua.config.max_calls,
-		      PJ_EINVAL);
-
-    if (pjsua.calls[call_index].inv == NULL) {
-	PJ_LOG(3,(THIS_FILE, "Call %d already disconnected"));
-	return PJSIP_ESESSIONTERMINATED;
-    }
-
-    status = pjsip_inv_answer(pjsua.calls[call_index].inv,
-			      code, NULL, NULL, &tdata);
-    if (status == PJ_SUCCESS)
-	status = pjsip_inv_send_msg(pjsua.calls[call_index].inv,
-				    tdata);
-
-    if (status != PJ_SUCCESS)
-	pjsua_perror(THIS_FILE, "Unable to create/send response", 
-		     status);
-
+    if (call_id != -1) {
+	reset_call(call_id);
+    }
+
+    PJSUA_UNLOCK();
     return status;
 }
@@ -415,4 +342,5 @@
 /**
  * Handle incoming INVITE request.
+ * Called by pjsua_core.c
  */
 pj_bool_t pjsua_call_on_incoming(pjsip_rx_data *rdata)
@@ -424,6 +352,7 @@
     unsigned options = 0;
     pjsip_inv_session *inv = NULL;
-    int acc_index;
-    unsigned call_index;
+    int acc_id;
+    pjsua_call *call;
+    int call_id = -1;
     pjmedia_sdp_session *answer;
     pj_status_t status;
@@ -442,5 +371,5 @@
     /* Verify that we can handle the request. */
     status = pjsip_inv_verify_request(rdata, &options, NULL, NULL,
-				      pjsua.endpt, &response);
+				      pjsua_var.endpt, &response);
     if (status != PJ_SUCCESS) {
 
@@ -453,5 +382,5 @@
 
 	    pjsip_get_response_addr(response->pool, rdata, &res_addr);
-	    pjsip_endpt_send_response(pjsua.endpt, &res_addr, response, 
+	    pjsip_endpt_send_response(pjsua_var.endpt, &res_addr, response, 
 				      NULL, NULL);
 
@@ -459,5 +388,5 @@
 
 	    /* Respond with 500 (Internal Server Error) */
-	    pjsip_endpt_respond_stateless(pjsua.endpt, rdata, 500, NULL,
+	    pjsip_endpt_respond_stateless(pjsua_var.endpt, rdata, 500, NULL,
 					  NULL, NULL);
 	}
@@ -472,11 +401,11 @@
 
     /* Find free call slot. */
-    for (call_index=0; call_index < pjsua.config.max_calls; ++call_index) {
-	if (pjsua.calls[call_index].inv == NULL)
+    for (call_id=0; call_id<(int)pjsua_var.ua_cfg.max_calls; ++call_id) {
+	if (pjsua_var.calls[call_id].inv == NULL)
 	    break;
     }
 
-    if (call_index == PJSUA_MAX_CALLS) {
-	pjsip_endpt_respond_stateless(pjsua.endpt, rdata, 
+    if (call_id == (int)pjsua_var.ua_cfg.max_calls) {
+	pjsip_endpt_respond_stateless(pjsua_var.endpt, rdata, 
 				      PJSIP_SC_BUSY_HERE, NULL,
 				      NULL, NULL);
@@ -484,37 +413,35 @@
     }
 
+    /* Clear call descriptor */
+    reset_call(call_id);
+
+    call = &pjsua_var.calls[call_id];
+
     /* Mark call start time. */
-    pj_gettimeofday(&pjsua.calls[call_index].start_time);
-
-    /* Reset first response time */
-    pjsua.calls[call_index].res_time.sec = 0;
+    pj_gettimeofday(&call->start_time);
 
     /* Get media capability from media endpoint: */
-
-    status = pjmedia_endpt_create_sdp( pjsua.med_endpt, rdata->tp_info.pool, 1,
-				       &pjsua.calls[call_index].skinfo, 
-				       &answer );
-    if (status != PJ_SUCCESS) {
-	pjsip_endpt_respond_stateless(pjsua.endpt, rdata, 500, NULL,
+    status = pjmedia_endpt_create_sdp( pjsua_var.med_endpt, 
+				       rdata->tp_info.pool, 1,
+				       &call->skinfo, &answer );
+    if (status != PJ_SUCCESS) {
+	pjsip_endpt_respond_stateless(pjsua_var.endpt, rdata, 500, NULL,
 				      NULL, NULL);
-
 	return PJ_TRUE;
     }
 
-    /* TODO: 
-     *
+    /* 
      * Get which account is most likely to be associated with this incoming
      * call. We need the account to find which contact URI to put for
      * the call.
      */
-    acc_index = 0;
+    acc_id = pjsua_acc_find_for_incoming(rdata);
 
     /* Create dialog: */
-
     status = pjsip_dlg_create_uas( pjsip_ua_instance(), rdata,
-				   &pjsua.config.acc_config[acc_index].contact,
+				   &pjsua_var.acc[acc_id].cfg.contact, 
 				   &dlg);
     if (status != PJ_SUCCESS) {
-	pjsip_endpt_respond_stateless(pjsua.endpt, rdata, 500, NULL,
+	pjsip_endpt_respond_stateless(pjsua_var.endpt, rdata, 500, NULL,
 				      NULL, NULL);
 
@@ -522,10 +449,14 @@
     }
 
+    /* Set credentials */
+    if (pjsua_var.acc[acc_id].cred_cnt) {
+	pjsip_auth_clt_set_credentials(&dlg->auth_sess, 
+				       pjsua_var.acc[acc_id].cred_cnt,
+				       pjsua_var.acc[acc_id].cred);
+    }
 
     /* Create invite session: */
-
     status = pjsip_inv_create_uas( dlg, rdata, answer, 0, &inv);
     if (status != PJ_SUCCESS) {
-
 	pjsip_dlg_respond(dlg, rdata, 500, NULL, NULL, NULL);
 	pjsip_dlg_terminate(dlg);
@@ -534,10 +465,9 @@
 
 
-    /* Create and attach pjsua data to the dialog: */
-
-    pjsua.calls[call_index].inv = inv;
-
-    dlg->mod_data[pjsua.mod.id] = &pjsua.calls[call_index];
-    inv->mod_data[pjsua.mod.id] = &pjsua.calls[call_index];
+    /* Create and attach pjsua_var data to the dialog: */
+    call->inv = inv;
+
+    dlg->mod_data[pjsua_var.mod.id] = call;
+    inv->mod_data[pjsua_var.mod.id] = call;
 
 
@@ -545,26 +475,12 @@
      * If auto-answer flag is set, send 200 straight away, otherwise send 100.
      */
-    
     status = pjsip_inv_initial_answer(inv, rdata, 
-				      (pjsua.config.auto_answer ? 
-				      pjsua.config.auto_answer : 100), 
-				      NULL, NULL, &response);
-    if (status != PJ_SUCCESS) {
-	
-	int st_code;
-
+				      100, NULL, NULL, &response);
+    if (status != PJ_SUCCESS) {
 	pjsua_perror(THIS_FILE, "Unable to send answer to incoming INVITE", 
 		     status);
 
-	/* If failed to send 2xx response, there's a good chance that it is
-	 * because SDP negotiation has failed.
-	 */
-	if (pjsua.config.auto_answer/100 == 2)
-	    st_code = PJSIP_SC_UNSUPPORTED_MEDIA_TYPE;
-	else
-	    st_code = 500;
-
-	pjsip_dlg_respond(dlg, rdata, st_code, NULL, NULL, NULL);
-	pjsip_inv_terminate(inv, st_code, PJ_FALSE);
+	pjsip_dlg_respond(dlg, rdata, 500, NULL, NULL, NULL);
+	pjsip_inv_terminate(inv, 500, PJ_FALSE);
 	return PJ_TRUE;
 
@@ -575,47 +491,10 @@
     }
 
-    if (pjsua.config.auto_answer < 200) {
-	PJ_LOG(3,(THIS_FILE,
-		  "\nIncoming call!!\n"
-		  "From: %.*s\n"
-		  "To:   %.*s\n"
-		  "(press 'a' to answer, 'h' to decline)",
-		  (int)dlg->remote.info_str.slen,
-		  dlg->remote.info_str.ptr,
-		  (int)dlg->local.info_str.slen,
-		  dlg->local.info_str.ptr));
-    } else {
-	PJ_LOG(3,(THIS_FILE,
-		  "Call From:%.*s To:%.*s was answered with %d (%s)",
-		  (int)dlg->remote.info_str.slen,
-		  dlg->remote.info_str.ptr,
-		  (int)dlg->local.info_str.slen,
-		  dlg->local.info_str.ptr,
-		  pjsua.config.auto_answer,
-		  pjsip_get_status_text(pjsua.config.auto_answer)->ptr ));
-    }
-
-    ++pjsua.call_cnt;
-
-    /* Schedule timer to refresh. */
-    if (pjsua.config.uas_refresh > 0) {
-	schedule_call_timer( &pjsua.calls[call_index], 
-			     &pjsua.calls[call_index].refresh_tm,
-			     REFRESH_CALL_TIMER,
-			     pjsua.config.uas_refresh);
-    }
-
-    /* Schedule timer to hangup call. */
-    if (pjsua.config.uas_duration > 0) {
-	schedule_call_timer( &pjsua.calls[call_index], 
-			     &pjsua.calls[call_index].hangup_tm,
-			     HANGUP_CALL_TIMER,
-			     pjsua.config.uas_duration);
-    }
+    ++pjsua_var.call_cnt;
+
 
     /* Notify application */
-    if (pjsua.cb.on_incoming_call)
-	pjsua.cb.on_incoming_call(acc_index, call_index, rdata);
-
+    if (pjsua_var.ua_cfg.cb.on_incoming_call)
+	pjsua_var.ua_cfg.cb.on_incoming_call(acc_id, call_id, rdata);
 
     /* This INVITE request has been handled. */
